using System;
using System.Diagnostics;

namespace ConsoleApplication1
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: Add code to start application here
			//
				
			//This is for the m1 server.  It will contain an array of x routers
			//Foreach router, we need to create a socket and send a message to that
			//router telling it the source and destination servers.  The router then calls
			//the findBandwidth function and returns a bandwidth time.  This time needs
			//to be sent back through the socket to the m1 server, who shall store it in
			// the bandwidths array.  We then will choose the best available bandwidth 
			//and send it through that router
			string[] routers = new string[5];
			//routers[0] = "www.conacyt.mx";
			routers[0] = "wind.uccs.edu";
			//routers[1] = "www.cominf.com";
			routers[1] = "wait.uccs.edu";
			routers[2] = "another router";
			routers[3] = "another router";
			routers[4] = "another router";
			int[] bandwidths = new int[5];
			//string destinationServer = "www.yahoo.com";
			//string sourceServer = "www.google.com";

			foreach( string router in routers )
			{
				//DO Socket Creation and call findbandwidth at router
				//Then send the bandwidth back and save in bandWidths
			}


			//USED FOR TESTING ONLY
			bandwidths[0] = findBandwidth(routers[0], routers[1]);
			Console.WriteLine("Timed route takes " + bandwidths[0] + "millliseconds");
								 Console.ReadLine();
		}


		//This function call should be in the reciever (k1 or k2 or kn)
		//It will take the two servers and return the time for getting from one to the
		//other through this router.  It returns the total time.  It uses the ping utility
		//to calculate the time.  It sends 4 128 byte packages to measure the time
		public static int findBandwidth(string sourceServer, string destinationServer) 
		{
			int dwStart = 0, dwStop = 0;
			int bandwidthTime = 0;

			//Setup a process to use ping call
			System.Diagnostics.Process p = new Process();
			p.StartInfo.FileName="C:\\WINDOWS\\system32\\ping";
			p.StartInfo.RedirectStandardOutput=true;
			p.StartInfo.UseShellExecute=true;
			p.StartInfo.UseShellExecute=false;

			//Get bandwidth from this server to destination
			p.StartInfo.Arguments="-n 4 -l 128 -i 10 " + destinationServer;
			//Start Timing
			dwStart = System.Environment.TickCount; 
			//Start processs 'ping'
			p.Start();
			p.WaitForExit();						
			//Stop Timing
			dwStop = System.Environment.TickCount - dwStart; 
			Console.WriteLine("The destinationServer is " + destinationServer);
			Console.WriteLine("Time to destinationServer is: " + dwStop);
			//Save time 
			bandwidthTime = dwStop;
				
			//Repeat for sourceServer
			p.StartInfo.Arguments="-n 4 -l 128 -i 10 " + sourceServer;
			//Start Timing
			dwStart = System.Environment.TickCount; 
			p.Start();
			p.WaitForExit();						
			//Stop Timing
			dwStop = System.Environment.TickCount - dwStart; 
			Console.WriteLine("The sourceServer is " + sourceServer);
			Console.WriteLine("Time to sourceServer is: " + dwStop);
			//Save time 
			bandwidthTime = bandwidthTime + dwStop;
		
			p.Dispose(); 

			return bandwidthTime;

		}
	}
}